#include "stdafx.h"
#include "Dic_Mod.h"
#include "hash.hpp"

CDic_Mod g_cDic;

CDic_Mod::CDic_Mod(void)
{
	KeyIndex.clear();
	KeyBook.clear();

	ValueList.clear();

	BookN=0;
	WordN=0;

	NullWord.WordLen=0;
	NullWord.WordN=0;
}

CDic_Mod::~CDic_Mod(void)
{
}

bool CDic_Mod::PreDict(LPSTR szDst,LPCSTR cszSrc)
{
	bool bRet=false;

	int nLen = (int)strlen(cszSrc);

	queue <ChangeList> arChange;

	DicWord DicTmp = NullWord;

	for(int i=0;i<nLen-1;i++)
	{
		for(int j=nLen-1;j>i;j--)
		{
			DicTmp = FindKey(cszSrc,i,j);
			if(DicTmp.WordLen>0)
			{
				ChangeList elTemp;

				elTemp.nStart=i;
				elTemp.nEnd=j;
				elTemp.nWord=DicTmp.WordN;

				arChange.push(elTemp);

				i=j;
				bRet=true;
				break;
			}
		}
	}

	int nDstHead=0;

	int nHead=0;
	int nTail=0;
	while(!arChange.empty())
	{
		ChangeList elTemp=arChange.front();

		nTail = elTemp.nStart-1;
		if(nTail-nHead>0)
		{
			lstrcpynA(szDst+nDstHead,cszSrc+nHead,nTail-nHead);
			nDstHead += nTail-nHead;
		}

		lstrcpyA(szDst+nDstHead,ValueList[elTemp.nWord].c_str());
		nHead = elTemp.nEnd+1;
		nDstHead += elTemp.nEnd - elTemp.nStart;

		arChange.pop();
	}
	lstrcpyA(szDst+nDstHead,cszSrc+nHead);

	return bRet;
}

void CDic_Mod::SetKey(LPCSTR cszKeyWord, LPCSTR cszDataWord)
{
	map<UINT,DicWord> EmptyMap;
	DicWord TempWord;

	map<int,int>::iterator iterIndex;

	TempWord.WordLen = (int)strlen(cszKeyWord);
	TempWord.WordN = WordN++;

	UINT Hash=MakeStringHash(cszKeyWord);
	int IndexChar=(int)TempWord.WordLen*65536+cszKeyWord[0]*256+cszKeyWord[1];
	int ValuePointer=0;

	iterIndex = KeyIndex.find(IndexChar);
	if(iterIndex==KeyIndex.end()){
		//  ʴٸ
		KeyIndex[IndexChar]=BookN;
		KeyBook.push_back(EmptyMap);
		//  ִ´.

		ValuePointer=BookN++;
	}
	else{
		// ִٸ
		ValuePointer=iterIndex->second;
	}

	KeyBook[ValuePointer][Hash]=TempWord;
	ValueList.push_back(cszDataWord);
	//
}

DicWord CDic_Mod::FindKey(LPCSTR cszSource, int nStart, int nEnd)
{
	//켱 ڿ ߶󳻵  ==;
	char FindText[2048]="";
	int nEndLen=(int)strlen(cszSource)-1; //''̴ϱ

	if(nEnd!=-1 && nEnd<=nEndLen){
		//End -1 ƴϰ(-1 !)
		//End 밡   ִٸ.
		nEndLen=nEnd;
	}

	int nTextLen=0;
	for(int i=nStart;i<=nEnd;i++)FindText[nTextLen++]=cszSource[i];
	FindText[nTextLen]='\0';
	//


	//˻ ۾ .
	map<int,int>::iterator iterIndex;
	int IndexChar=65536*nTextLen+FindText[0]*256+FindText[1];

	iterIndex = KeyIndex.find(IndexChar); //1 ˻
	if(iterIndex==KeyIndex.end()){
		// ٸ.
		return NullWord;
	}
	else{
		UINT Hash=MakeStringHash(FindText); //Hash
		map<UINT,DicWord>::iterator iterBook;

		int ValuePointer=iterIndex->second;

		iterBook = KeyBook[ValuePointer].find(Hash); //2 ˻
		if(iterBook != KeyBook[ValuePointer].end()){
			//2ܰ  ִٸ,
			return iterBook->second;
		}
		else{
			//⵵ ٸ,
			return NullWord;
		}
	}
}

